--------------------------------------------------------------------------
--                                                                      --
--           Copyright: Copyright (C) 2000-2010 CNRS/IN2P3              --
--                                                                      --
-- Narval framework is free  software; you can redistribute  it and/or  --
-- modify  it   under  terms  of  the  GNU General  Public  License as  --
-- published  by  the  Free Software Foundation; either version  2, or  --
-- (at your option) any later version. Narval framework is distributed  --
-- in the hope  that  they will  be useful, but  WITHOUT ANY WARRANTY;  --
-- without even the implied warranty of  MERCHANTABILITY or FITNESS FOR --
-- A PARTICULAR PURPOSE. See the  GNU. General Public License for more  --
-- details. You should have received  a copy of the GNU General Public  --
-- License distributed with Narval; see file COPYING. If not, write to  --
-- the Free Software  Foundation,  Inc., 51 Franklin St,  Fifth Floor,  --
-- Boston, MA 02110-1301 USA.                                           --
--------------------------------------------------------------------------
package Narval.Actors.Actives.Producers is

   type Producer_Type is abstract new Active_Actor_Type
     (A_Producer) with private;
   type Producer_Access is access all Producer_Type;

private

   type Producer_Type is abstract new Active_Actor_Type (A_Producer)
     with record
        Pause : Start_Stop_Handling.Synchro_Pause_Type;
     end record;
   procedure On_Suspend (Object : access Producer_Type);
   procedure On_Resume (Object : access Producer_Type);

   procedure Distribute_Work (Object : access Producer_Type);

end Narval.Actors.Actives.Producers;
